#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "acidblood.h"
#include "acidfuncs.h"
#include "tracking.h"
#include "parallel.h"
#include "parallel.c"
/*************************************

Hint: hook 8 leds up to the parallel port

*************************************/

parallel_t * PORT;
int State;

int robomod_nextState(char *replyto, struct userlist *user, char *data);
int robomod_prevState(char *replyto, struct userlist *user, char *data);
int robomod_status(char *replyto, struct userlist *user, char *data);


int module_init(void *module)
{
	// initialize a parallel port
        PORT = parallel_Init(0x378);
        
        // configure commands
           // left
           addusrcommand(module, "next", robomod_nextState, 99);
           // right
           addusrcommand(module, "prev", robomod_prevState, 99);

           addusrcommand(module, "status", robomod_status, 99);

	return(1) ;
}

int module_shutdown(void *module)
{

        //close ports
        parallel_Destroy(PORT);
        
        // remove commands
           // left
           delusrcommand(module, "next");
           // right
           delusrcommand(module, "prev");     
	   delusrcommand(module, "status");
	return(1) ;
}

//int dicemod_roll(char *replyto, struct userlist *user, char *data)

int robomod_nextState(char *replyto, struct userlist *user, char *data) {

   unsigned long stateTableForward[] = {  /* state machine, cooooool */
      0x0101,                     /* ( I just thought this up... ) */
      0x0202,                     /* the first to digits are the next offset */
      0x0304,                     /* the last two digits are the data */
      0x0408,
      0x0510,
      0x0620,
      0x0740,
      0x0080  };
       
      State  = (*(stateTableForward + State) & 0xFF00) >> 8;
      parallel_WriteData (PORT, *(stateTableForward + State) & 0x00FF);

      return(1);
}

int robomod_prevState(char *replyto, struct userlist *user, char *data) {

   unsigned long stateTableBackward[] = {  /* state machine, cooooool */
      0x0701,                     /* ( I just thought this up... ) */
      0x0002,
      0x0104,
      0x0208,
      0x0310,
      0x0420,
      0x0540,
      0x0680  };
       
      State  = (*(stateTableBackward + State) & 0xFF00) >> 8;
      parallel_WriteData (PORT, *(stateTableBackward + State) & 0x00FF);

      return(1);

}


int robomod_status(char *replyto, struct userlist *user, char *data) {

        struct socket_info *socket ;
        socket=user->userinfo->server->sinfo ;
	
	privmsg(socket, replyto, "Status is: %d \n", State );
	return(0) ;
}


